import NavigateAppPage from '../../common/NavigateAppPage.macos';
import FocusZonePageObject from '../pages/FocusZonePageObject.macos';
import { PAGE_TIMEOUT, BOOT_APP_TIMEOUT } from '../../common/consts';

// Before testing begins, allow up to 60 seconds for app to open
describe('FocusZone Testing Initialization', function () {
  it('Wait for app load', () => {
    NavigateAppPage.waitForPageDisplayed(BOOT_APP_TIMEOUT);
    expect(NavigateAppPage.isPageLoaded()).toBeTruthy();
  });

  it('Click and navigate to FocusZone test page', () => {
    /* Scroll to component test page button in scrollview if not already visible*/
    FocusZonePageObject.scrollToComponentButton();
    FocusZonePageObject.waitForButtonDisplayed(PAGE_TIMEOUT);

    /* Click on component button to navigate to test page */
    NavigateAppPage.clickAndGoToFocusZonePage();
    FocusZonePageObject.waitForPageDisplayed(PAGE_TIMEOUT);

    expect(FocusZonePageObject.isPageLoaded()).toBeTruthy();
  });
});
