import { AliasColorTokens, Variants } from '@fluentui-react-native/theme-types';

export function mapPipelineToTheme(pipelineOutput: any): AliasColorTokens {
  return {
    neutralForeground1: pipelineOutput.neutralForeground1.fillColorRest,
    neutralForeground1Hover: pipelineOutput.neutralForeground1.fillColorHover,
    neutralForeground1Pressed: pipelineOutput.neutralForeground1.fillColorPressed,
    neutralForeground1Selected: pipelineOutput.neutralForeground1.fillColorSelected,
    neutralForeground2: pipelineOutput.neutralForeground2.fillColorRest,
    neutralForeground2Hover: pipelineOutput.neutralForeground2.fillColorHover,
    neutralForeground2Pressed: pipelineOutput.neutralForeground2.fillColorPressed,
    neutralForeground2Selected: pipelineOutput.neutralForeground2.fillColorSelected,
    neutralForeground2BrandHover: pipelineOutput.neutralForeground2.fillColorBrandHover,
    neutralForeground2BrandPressed: pipelineOutput.neutralForeground2.fillColorBrandPressed,
    neutralForeground2BrandSelected: pipelineOutput.neutralForeground2.fillColorBrandSelected,
    neutralForeground3: pipelineOutput.neutralForeground3.fillColorRest,
    neutralForeground3Hover: pipelineOutput.neutralForeground3.fillColorHover,
    neutralForeground3Pressed: pipelineOutput.neutralForeground3.fillColorPressed,
    neutralForeground3Selected: pipelineOutput.neutralForeground3.fillColorSelected,
    neutralForeground3BrandHover: pipelineOutput.neutralForeground3.fillColorBrandHover,
    neutralForeground3BrandPressed: pipelineOutput.neutralForeground3.fillColorBrandPressed,
    neutralForeground3BrandSelected: pipelineOutput.neutralForeground3.fillColorBrandSelected,
    neutralForeground4: pipelineOutput.neutralForeground4.fillColorRest,
    neutralForegroundDisabled: pipelineOutput.neutralForegroundDisabled.fillColorRest,

    brandForegroundLink: pipelineOutput.brandForegroundLink.fillColorRest,
    brandForegroundLinkHover: pipelineOutput.brandForegroundLink.fillColorHover,
    brandForegroundLinkPressed: pipelineOutput.brandForegroundLink.fillColorPressed,
    brandForegroundLinkSelected: pipelineOutput.brandForegroundLink.fillColorSelected,
    compoundBrandForeground1: pipelineOutput.compoundBrandForeground1.fillColorRest,
    compoundBrandForeground1Hover: pipelineOutput.compoundBrandForeground1.fillColorHover,
    compoundBrandForeground1Pressed: pipelineOutput.compoundBrandForeground1.fillColorPressed,
    brandForeground1: pipelineOutput.brandForeground1.fillColorRest,
    brandForeground1Disabled: pipelineOutput.brandForeground1.fillColorDisabled,
    brandForeground1Pressed: pipelineOutput.brandForeground1.fillColorPressed,
    brandForeground2: pipelineOutput.brandForeground2.fillColorRest,

    neutralForegroundInverted: pipelineOutput.neutralForegroundInverted.fillColorRest,
    neutralForegroundOnBrand: pipelineOutput.neutralForegroundOnBrand.fillColorRest,
    neutralForegroundOnBrandHover: pipelineOutput.neutralForegroundOnBrand.fillColorHover,
    neutralForegroundOnBrandPressed: pipelineOutput.neutralForegroundOnBrand.fillColorPressed,
    neutralForegroundOnBrandSelected: pipelineOutput.neutralForegroundOnBrand.fillColorSelected,
    neutralForegroundInvertedLink: pipelineOutput.neutralForegroundInvertedLink.fillColorRest,
    neutralForegroundInvertedLinkHover: pipelineOutput.neutralForegroundInvertedLink.fillColorHover,
    neutralForegroundInvertedLinkPressed: pipelineOutput.neutralForegroundInvertedLink.fillColorPressed,
    neutralForegroundInvertedLinkSelected: pipelineOutput.neutralForegroundInvertedLink.fillColorSelected,

    neutralBackground1: pipelineOutput.neutralBackground1.fillColorRest,
    neutralBackground1Hover: pipelineOutput.neutralBackground1.fillColorHover,
    neutralBackground1Pressed: pipelineOutput.neutralBackground1.fillColorPressed,
    neutralBackground1Selected: pipelineOutput.neutralBackground1.fillColorSelected,
    neutralBackground2: pipelineOutput.neutralBackground2.fillColorRest,
    neutralBackground2Hover: pipelineOutput.neutralBackground2.fillColorHover,
    neutralBackground2Pressed: pipelineOutput.neutralBackground2.fillColorPressed,
    neutralBackground2Selected: pipelineOutput.neutralBackground2.fillColorSelected,
    neutralBackground3: pipelineOutput.neutralBackground3.fillColorRest,
    neutralBackground3Hover: pipelineOutput.neutralBackground3.fillColorHover,
    neutralBackground3Pressed: pipelineOutput.neutralBackground3.fillColorPressed,
    neutralBackground3Selected: pipelineOutput.neutralBackground3.fillColorSelected,
    neutralBackground4: pipelineOutput.neutralBackground4.fillColorRest,
    neutralBackground4Hover: pipelineOutput.neutralBackground4.fillColorHover,
    neutralBackground4Pressed: pipelineOutput.neutralBackground4.fillColorPressed,
    neutralBackground4Selected: pipelineOutput.neutralBackground4.fillColorSelected,
    neutralBackground5: pipelineOutput.neutralBackground5.fillColorRest,
    neutralBackground5Hover: pipelineOutput.neutralBackground5.fillColorHover,
    neutralBackground5Pressed: pipelineOutput.neutralBackground5.fillColorPressed,
    neutralBackground5Selected: pipelineOutput.neutralBackground5.fillColorSelected,
    neutralBackground6: pipelineOutput.neutralBackground6.fillColorRest,
    neutralBackgroundInverted: pipelineOutput.neutralBackgroundInverted.fillColorRest,

    subtleBackground: pipelineOutput.subtleBackground.fillColorRest,
    subtleBackgroundHover: pipelineOutput.subtleBackground.fillColorHover,
    subtleBackgroundPressed: pipelineOutput.subtleBackground.fillColorPressed,
    subtleBackgroundSelected: pipelineOutput.subtleBackground.fillColorSelected,

    transparentBackground: pipelineOutput.transparentBackground.fillColorRest,
    transparentBackgroundHover: pipelineOutput.transparentBackground.fillColorHover,
    transparentBackgroundPressed: pipelineOutput.transparentBackground.fillColorPressed,
    transparentBackgroundSelected: pipelineOutput.transparentBackground.fillColorSelected,

    neutralBackgroundDisabled: pipelineOutput.neutralBackgroundDisabled.fillColorRest,

    neutralStencil1: pipelineOutput.neutralStencil1.fillColorRest,
    neutralStencil2: pipelineOutput.neutralStencil2.fillColorRest,

    brandBackground: pipelineOutput.brandBackground.fillColorRest,
    brandBackgroundHover: pipelineOutput.brandBackground.fillColorHover,
    brandBackgroundPressed: pipelineOutput.brandBackground.fillColorPressed,
    brandBackgroundDisabled: pipelineOutput.brandBackground.fillColorDisabled,
    brandBackgroundSelected: pipelineOutput.brandBackground.fillColorSelected,
    compoundBrandBackground1: pipelineOutput.compoundBrandBackground1.fillColorRest,
    compoundBrandBackground1Hover: pipelineOutput.compoundBrandBackground1.fillColorHover,
    compoundBrandBackground1Pressed: pipelineOutput.compoundBrandBackground1.fillColorPressed,

    brandBackgroundStatic: pipelineOutput.brandBackgroundStatic.fillColorRest,
    brandBackground2: pipelineOutput.brandBackground2.fillColorRest,

    neutralStrokeAccessible: pipelineOutput.neutralStrokeAccessible.strokeColorRest,
    neutralStrokeAccessibleHover: pipelineOutput.neutralStrokeAccessible.strokeColorHover,
    neutralStrokeAccessiblePressed: pipelineOutput.neutralStrokeAccessible.strokeColorPressed,
    neutralStrokeAccessibleSelected: pipelineOutput.neutralStrokeAccessible.strokeColorSelected,
    neutralStroke1: pipelineOutput.neutralStroke1.strokeColorRest,
    neutralStroke1Hover: pipelineOutput.neutralStroke1.strokeColorHover,
    neutralStroke1Pressed: pipelineOutput.neutralStroke1.strokeColorPressed,
    neutralStroke1Selected: pipelineOutput.neutralStroke1.strokeColorSelected,
    neutralStroke2: pipelineOutput.neutralStroke2.strokeColorRest,
    neutralStroke3: pipelineOutput.neutralStroke3.strokeColorRest,
    brandStroke1: pipelineOutput.brandStroke1.strokeColorRest,
    brandStroke2: pipelineOutput.brandStroke2.strokeColorRest,
    compoundBrandStroke1: pipelineOutput.compoundBrandStroke1.strokeColorRest,
    compoundBrandStroke1Hover: pipelineOutput.compoundBrandStroke1.strokeColorHover,
    compoundBrandStroke1Pressed: pipelineOutput.compoundBrandStroke1.strokeColorPressed,
    neutralStrokeDisabled: pipelineOutput.neutralStrokeDisabled.strokeColorRest,

    transparentStroke: pipelineOutput.transparentStroke.strokeColorRest,
    transparentStrokeInteractive: pipelineOutput.transparentStroke.strokeColorHover,
    transparentStrokeDisabled: pipelineOutput.transparentStroke.strokeColorDisabled,

    strokeFocus1: pipelineOutput.strokeFocus1.strokeColorRest,
    strokeFocus2: pipelineOutput.strokeFocus2.strokeColorRest,

    redBackground1: pipelineOutput.redBackground1.fillColorRest,
    redBackground2: pipelineOutput.redBackground2.fillColorRest,
    redBackground3: pipelineOutput.redBackground3.fillColorRest,
    redForeground1: pipelineOutput.redForeground1.fillColorRest,
    redForeground2: pipelineOutput.redBackground2.fillColorRest,
    redForeground3: pipelineOutput.redBackground3.fillColorRest,
    redBorderActive: pipelineOutput.redBorderActive.strokeColorRest,
    redBorder1: pipelineOutput.redBorder1.strokeColorRest,
    redBorder2: pipelineOutput.redBorder2.strokeColorRest,
  };
}

export function mapFontPipelineToTheme(pipelineOutput: any): Partial<Variants> {
  return {
    caption1: createVariantValue(pipelineOutput.caption1),
    body1: createVariantValue(pipelineOutput.body1),
    body1Strong: createVariantValue(pipelineOutput.body1Strong),
    body2: createVariantValue(pipelineOutput.body2),
    body2Strong: createVariantValue(pipelineOutput.body2Strong),
    subtitle1: createVariantValue(pipelineOutput.subtitle1),
    subtitle1Strong: createVariantValue(pipelineOutput.subtitle1Strong),
    subtitle2: createVariantValue(pipelineOutput.subtitle2),
    subtitle2Strong: createVariantValue(pipelineOutput.subtitle2Strong),
    title1: createVariantValue(pipelineOutput.title1),
    title1Strong: createVariantValue(pipelineOutput.title1Strong),
    largeTitle: createVariantValue(pipelineOutput.largeTitle),
    display: createVariantValue(pipelineOutput.display),
  };
}

function createVariantValue(variant: any) {
  return { face: 'primary', size: variant.fontSize, weight: variant.fontWeight };
}
